CREATE TABLE if not exists par.omissodeclarado_confirmado(
	odcid serial4 NOT NULL,
	odctipo_programa VARCHAR(6) NOT NULL,
	odcnumeroprocesso VARCHAR(25) NOT NULL,
	odcdata_criacao timestamp DEFAULT CURRENT_TIMESTAMP NOT null,
	odcdata_alteracao timestamp DEFAULT CURRENT_TIMESTAMP NOT null,
	odeid integer NOT NULL,
	odcstatus  varchar(1) DEFAULT 'A'::character varying NOT NULL,
	
	CONSTRAINT pk_omissodeclarado_confirmado PRIMARY KEY (odcid)
);

ALTER TABLE par.omissodeclarado_confirmado 
ADD CONSTRAINT fk_omissodeclarado_confirmado_odeid FOREIGN KEY (odeid) 
REFERENCES par.omissodeclarado(odeid) ON DELETE CASCADE;


CREATE INDEX idx_omissodeclarado_confirmado_numeroprocesso ON par.omissodeclarado_confirmado (odcnumeroprocesso);

COMMENT on table par.omissodeclarado_confirmado  is 'Tabela derivada (par.omissodeclardo) par.omissodeclarado_confirmado - Registrar os processos confirmados para declaração de omissão'; 
comment ON COLUMN par.omissodeclarado_confirmado.odctipo_programa  is 'Informa tipo de programa (PAR, OBRA, PAC, PAR3)'; 
comment ON COLUMN par.omissodeclarado_confirmado.odcnumeroprocesso  is 'Informa número do processo'; 
comment ON COLUMN par.omissodeclarado_confirmado.odcdata_criacao  is 'Informa quando o processo foi declarado omisso confirmado'; 
comment ON COLUMN par.omissodeclarado_confirmado.odcdata_alteracao  is 'Informa quando o registro foi alterado nesta tabela'; 
comment ON COLUMN par.omissodeclarado_confirmado.odeid  is 'Chave estrangeira da tabela par.omissodeclarado - Tabela pai'; 
comment ON COLUMN par.omissodeclarado_confirmado.odcstatus  is 'Informa status do registro nesta tabela'; 


